#!/usr/bin/perl -w
# Author        : Pedro Velho
# last modified : 08/02/2010
$thisdir= "/home/velho/public_html/personal/phd/04-random/a-normal/";

open(RAWOUTPUT, ">".$thisdir."/dat/"."raw.links.data") || die "Sorry, couldn't open file ".$thisdir."dat/raw.deploy.data for writting...\n";
        
print RAWOUTPUT " File NFlows Size Exp LinkName FlowsOut FlowsIn \n";
    
#ls -1 deploy
@files = `ls -1 $thisdir/deploy/`;

my($File, $NFlows, $Size, $Exp, $count);



$count=1;


foreach (@files) { 
    chomp();
    $file = $_;

    my(@fields) = split(/-/, $file);

    if($fields[0] =~ m/waxman.*/ ){    
	$File = "platforms/brite/".$fields[0].".xml";
    }else{
	$File = "platforms/tiers/".$fields[0].".xml";
    }


    $FileName = $fields[0];
    $NFlows = $fields[3];
    $Size = $fields[5];
    $Exp = $fields[7];

    if(!defined $NFlows){
	#print "Missing experiment data skiping deployment '".$file."'...\n";
	next;
    }

    if($NFlows != 100){
	next;
    }

    if($Size != 100000000){
	next;
    }

    print "Working on file $file\n";
    print "file $File , flow $NFlows , size $Size , exp $Exp\n";

    open(DEPLOYMENT, "< $thisdir/deploy/$file") || die "Sorry couldn't open $file for reading\n";

    my %messages = ();
    $src="";
    $dst="";

    while(<DEPLOYMENT>){
	chomp();
	$line = $_;
	#print $line;

	if($line =~ m/.*<process.*/){
		
		$nodeName = $line;
		$nodeName =~ s/^.*host=.(.*).\s+function.*$/$1/;

		$proc = $line;
		$proc =~ s/^.*\s+function=.(.*)'>.*$/$1/;

	    if($proc eq "master"){
		$src = $nodeName;
	    }elsif ($proc eq "slave"){
		$dst = $nodeName;
		#print "Found message from $src to $dst\n";
		$$messages{$src}{$dst}++;
		#print "conter is $$messages{$src}{$dst}\n";
		$src = $dst = "";
	    }
	}
    }
    
    close(DEPLOYMENT);



    open(PLATFORM, "< ".$thisdir."/".$File) || die "Sorry, couldn't open file ".$thisdir."/".$File." for reading\n";

    $src = $dst = "";
    my %flowIn  = ();
    my %flowOut = ();

    while(<PLATFORM>){
	chomp();
	$line_plat = $_;

	if($line_plat =~ m/\s+<route\s+src=\"(.*)\"\s+dst=\"(.*)\">(.*)<\/route>/){
	    $src = $1;
	    $dst = $2;
	    $line_parsed = $3;


	    if( $$messages{$src}{$dst} ){

		#print "Found route with messages from $src to $dst\n";

		$line_parsed =~ s/[^_\d\/]*//g;
		my(@route_links) = split('/', $line_parsed);

		foreach $link (@route_links) {
		    if($link =~ m/(\d+)_(\d+)/){
			$a = $1;
			$b = $2;
		    }
		
		    if($a < $b){
			$flow = $a."_".$b;
			$flowIn{$flow}++;
		    }else{
			$flow = $b."_".$a;
			$flowOut{$flow}++;
		    }    
		}
	    }
	}
    }
    close(PLATFORM);

    print "Printing the keys for file $FileName.xml\n";
    %seen = ();

    foreach  my $key ( keys %flowIn , keys %flowOut ){
	unless ($seen{$key}) {
	    $seen{$key} = 1;
	    if( $flowOut{$key} && $flowIn{$key} ){
		    #print " \"$FileName.xml\" $NFlows $Size $Exp $key $flowOut{$key} $flowIn{$key}\n";
		    print RAWOUTPUT "$count \"$FileName.xml\" $NFlows $Size $Exp $key $flowOut{$key} $flowIn{$key}\n";
	    }elsif( $flowOut{$key}){
		    #print " \"$FileName.xml\" $NFlows $Size $Exp $key $flowOut{$key} 0\n";
		    print RAWOUTPUT "$count \"$FileName.xml\" $NFlows $Size $Exp $key $flowOut{$key} 0\n";	    
	    }elsif( $flowIn{$key}){
		    #print " \"$FileName.xml\" $NFlows $Size $Exp $key 0 $flowIn{$key}\n";
		    print RAWOUTPUT "$count \"$FileName.xml\" $NFlows $Size $Exp $key 0 $flowIn{$key}\n";	    
	    }
	    $count++;
	}
    }
}

close(RAWOUTPUT);
